import filecmp
import subprocess
import os
from time import sleep
from pathlib import Path


def install() -> None:
    delivered = False
    projectDir = Path(__file__).resolve().parent.parent
    homeDir = Path(os.getenv("HOME"))

    # Service file change for userspace
    with open(os.path.join(projectDir, "services/wthrc.service"), "r") as service:
        lines = service.readlines()
    lines[5] = "WorkingDirectory=" + os.path.join(projectDir, "src") + "\n"
    lines[6] = (
        "ExecStart=/usr/bin/python3 " + os.path.join(projectDir, "src/main.py") + "\n"
    )
    with open(os.path.join(projectDir, "services/wthrc.service"), "w") as service:
        service.writelines(lines)

    serviceDirExist = os.path.isdir(os.path.join(homeDir, ".config/systemd/user/"))
    services = ["wthrc.service", "conky.service"]
    if serviceDirExist:
        delivered = filecmp.cmpfiles(
            os.path.join(projectDir, "services/"),
            os.path.join(homeDir, ".config/systemd/user/"),
            services,
            shallow=True,
        )
        if delivered[2] != [] or delivered[1] != []:
            delivered = bool(False)

    if not delivered or not serviceDirExist:
        os.environ["DIR"] = str(projectDir)
        subprocess.call(["sh", os.path.join(projectDir, "scripts/install.sh")])
    subprocess.call(["sh", os.path.join(projectDir, "scripts/runner.sh")])

    sleep(5)
